<?php
// POS command: Do not modify
include_once 'PHPLibraries/DBFunctions.php';
include_once 'PHPLibraries/CartFunctions.php';

global $TempDictionary;

function StartSession()
{
	session_start();

		if (!isset ($_COOKIE[ini_get('session.name')]))
	{
		ResetCart();
	}
	
	if (!array_key_exists('Tongue', $_SESSION))
	{
		$_SESSION['Tongue'] = 0;
	}

	if (!array_key_exists('CurrentPropertyIndex', $_SESSION))
	{
		$_SESSION['CurrentPropertyIndex'] = 0;
	}
	
	if (!array_key_exists('LoggedIn', $_SESSION))
	{
		$_SESSION['LoggedIn'] = false;
	}
	
}

function AddBr($TempCount)
{
	for ($t = 1; $t <= $TempCount; $t++)
	{
		echo "<br>";
	}
}

function DeleteDirectory($directory, $empty = false)
{ 
     if(substr($directory,-1) == "/") { 
         $directory = substr($directory,0,-1); 
     } 

     if(!file_exists($directory) || !is_dir($directory)) { 
         return false; 
     } elseif(!is_readable($directory)) { 
         return false; 
     } else { 
         $directoryHandle = opendir($directory); 
         
         while ($contents = readdir($directoryHandle)) { 
             if($contents != '.' && $contents != '..') { 
                 $path = $directory . "/" . $contents; 
                 
                 if(is_dir($path)) { 
                     DeleteDirectory($path); 
                 } else { 
                     unlink($path); 
                 } 
             } 
         } 
         
         closedir($directoryHandle); 

         if($empty == false) { 
             if(!rmdir($directory)) { 
                 return false; 
             } 
         } 
         
         return true; 
     } 
 }

 function GetAllDirectories($TempBase)
{
	$TempReturn = array();

	if ($TempBase == '')
	{
		// Get the base directories
		
		$dirs = glob('./*', GLOB_ONLYDIR);
		
		for ($t = 0; $t < count($dirs); $t++)
		{
			$TempReturn[] = $dirs[$t];
			$TempSubDirs = GetAllDirectories($dirs[$t]);
		
			for ($g = 0; $g < count($TempSubDirs); $g++)
			{
				$TempReturn[] = $TempSubDirs[$g];
			}
		}
		
		for ($t = 0; $t < count($TempReturn); $t++)
		{
		$TempReturn[$t] = substr($TempReturn[$t], 2);
		}
		
	}
	else
	{
		$TempSubDirs = glob($TempBase."/*", GLOB_ONLYDIR);

		for ($g = 0; $g < count($TempSubDirs); $g++)
		{
			$TempReturn[] = $TempSubDirs[$g];
			
			$TempSubSubDirs = GetAllDirectories($TempSubDirs[$g]);
			
			for ($h = 0; $h < count($TempSubSubDirs); $h++)
			{
				$TempReturn[] = $TempSubSubDirs[$h];
			}
			
			
		}
	}

	return $TempReturn;
}

function LoadDictionary()
{
	global $TempDictionary;
	
	$TempDictionary = LoadUTF8FileIntoArray('Data/MultilingualDictionary.php');
	
	for ($t = 0; $t <= count($TempDictionary) - 1; $t++)
		{
		$TempDictionary[$t] = DecodeMessage($TempDictionary[$t]);
		}
		
}

function TranslateArray($TempArray, $TempTongue)
{
	global $TempDictionary;
	
		if (is_null($TempDictionary))
	{
		LoadDictionary();
	}

	$TempReturn = array();
	
	for ($t = 0; $t <= count($TempArray) - 1; $t++)
		{
		$TempReturn[$t] = Translate($TempArray[$t], $TempTongue);
		}
	
	return $TempReturn;
}

function Translate($TempText, $TempTongue)
{
	global $TempDictionary;

	if (is_null($TempDictionary))
	{
		LoadDictionary();
	}

	$TempReturn = $TempText;
	
	for ($t = 0; $t <= count($TempDictionary) - 1; $t++)
		{
		if ($TempDictionary[$t][0] == $TempText)
			{
			$TempReturn = $TempDictionary[$t][$TempTongue];
			}
		}
	
	return $TempReturn;
}

function SendHtmlEmail($TempTo, $TempSubject, $TempHtml)
{
// To send HTML mail, the Content-type header must be set
$headers  = 'MIME-Version: 1.0' . "\r\n";
$headers .= 'Content-type: text/html; charset=iso-8859-1' . "\r\n";

// Additional headers
//$headers .= 'To: orders@collectionsbp.com' . "\r\n";
$headers .= 'From: Website order' . "\r\n";
//$headers .= 'Cc: test@test.com' . "\r\n";
//$headers .= 'Bcc: test@test.com' . "\r\n";

// Mail it
mail($TempTo, $TempSubject, $TempHtml, $headers);	
}

function SortAccentedArray($TempArray)
{
	$TempReturn = array();
	
	$TempArrayToSort = array();
	
	for ($t = 0; $t <= count($TempArray) - 1; $t++)
	{
		$TempArrayToSort[RemoveAccentedCharacters($TempArray[$t])] = $TempArray[$t];
	}
	
	uksort($TempArrayToSort, "strnatcasecmp");
	
	foreach ($TempArrayToSort as $key => $value)
	{
		$TempReturn[] = $value;
	}
	
	return $TempReturn;
}

function SortByItemInArray($TempArray, $TempArrayIndex = 0)
{
	$TempReturn = array();
	
	$TempArrayToSort = array();
	
	for ($t = 0; $t < count($TempArray); $t++)
	{
		$TempArrayToSort[$TempArray[$t][$TempArrayIndex]] = $TempArray[$t];
	}
	uksort($TempArrayToSort, "strnatcasecmp");
	
	foreach ($TempArrayToSort as $key => $value)
	{
		$TempReturn[] = $value;
	}
	
	return $TempReturn;
}

function RemoveAccentedCharacters($TempString)
{
	$arrFrom = array("","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","","",""); 
	$arrTo =   array("a","A","a","A","a","A","a","a","A","e","E","e","E","e","E","e","E","i","I","i","I","i","I","i","I","o","o","o","O","o","O","o","O","u","U","u","U","u","U","u","U","c","C","y","Y","y","Y"); 
	
	$TempReturn = str_replace($arrFrom, $arrTo, $TempString);

	return $TempReturn;
}

function GetCubicSize($TempDimensions)
{
	$TempReturn = 0;
	
	$TempReturn = $TempReturn + ($TempDimensions['Width'] * $TempDimensions['Height'] * $TempDimensions['Length']);
	
	return $TempReturn;
}

function RemoveItemFromArray(&$TempArray, $TempIndex)
{

	$TempReturn = array();
	$TempNewIndex = 0;

	if ($TempIndex > -1)
	{
		
		foreach ($TempArray as $key => $item)
		{
			
			if ($key != $TempIndex)
			{
				$TempReturn[$TempNewIndex] = $item;
				$TempNewIndex++;
			}
			
		}
		
	}
	else
	{
		$TempReturn = $TempArray;
	}

	$TempArray = $TempReturn;
}

function FindObjectInArray($TempArray, $Key, $Value)
{
	$TempReturn = '';
	
	$TempCount = count($TempArray);
	
	for ($t = 0; $t <= $TempCount - 1; $t++)
	{
		if ($TempArray[$t][$Key] == $Value)
		{
			$TempReturn = $TempArray[$t];
		}
		
	}
	
	return $TempReturn;
	
}

function LockFile($MyFile)
{
	$TempReturn = '';

	if (file_exists($MyFile))
	{
		$fh = fopen($MyFile, 'r+')		or die($php_errormsg);
		$tries = 3;
		while ($tries > 0)
		{
			$locked = flock($fh,LOCK_EX);
			if (! $locked)
			{
				sleep(2);
				$tries--;
			}
			else
			{
				$tries = 0;
			}
		}
	
		if ($locked)
		{
			$TempReturn = $fh;
		}
	}

	return $TempReturn;
}

function UnlockFile(&$fh)
{
	flock($fh,LOCK_UN)			or die($php_errormsg);
	fclose($fh)					or die($php_errormsg);
}

function LoadOpenedFileIntoArray($fh)
{
	$MyArray = array();

	$TempCount=0;
	while (!feof ($fh)) 
	{ 
		$buffer = fgets($fh); 
		if (!feof($fh))
		{
			$MyArray[$TempCount] = rtrim($buffer); 
			$TempCount=$TempCount+1;
		}
	} 

	return $MyArray;
}

function SaveArrayToOpenedFile($fh, $MyArray)
{
	rewind($fh);
	ftruncate($fh, 0);
	
	foreach($MyArray as $key => $value)
	{
		fwrite($fh,$value."\r\n")	or die($php_errormsg);
	}
	fflush($fh)					or die($php_errormsg);
}

function LoadFileData($MyFile, $StartPos, $Length)
{

	$Data='';
	
	if (file_exists($MyFile) and $Length > 0)
	{
		$fh = fopen($MyFile, 'r')		or die($php_errormsg);
		$tries = 3;
		while ($tries > 0)
		{
			$locked = flock($fh,LOCK_EX | LOCK_NB);
			if (! $locked)
			{
				sleep(2);
				$tries--;
			}
			else
			{
				$tries = 0;
			}
		}
	
		if ($locked)
		{
		
			fseek($fh, $StartPos);
			$Data = fread($fh, $Length+1);
		
			flock($fh,LOCK_UN)			or die($php_errormsg);
			fclose($fh)					or die($php_errormsg);
		}
	}

	return $Data;
}

function FindUTF8ItemInArray($TempItem, $TempArray)
{
	$TempReturn = -1;
	
	for ($t = 0; $t <= count($TempArray) - 1; $t++)
	{
		if ($TempArray[$t] == $TempItem)
		{
			$TempReturn = $t;
		}
	}
	
	return $TempReturn;
}

function ConvertArrayFromUTF8($TempArray)
{
	$TempReturn = array();
	
	for ($t = 0; $t <= count($TempArray) -1; $t++)
	{
		$TempReturn[] = utf8_decode($TempArray[$t]);
	}
	
	if ($TempReturn[0][0] == '?')
	{
		$TempReturn[0] = substr($TempReturn[0],1);
	}
	
	return $TempReturn;
}

function LoadUTF8FileIntoArray($MyFile, $KeepFirstItem = false)
{
	$TempReturn = LoadFileIntoArray($MyFile);

	$TempReturn = ConvertArrayFromUTF8($TempReturn);

	if (!$KeepFirstItem)
	{
		RemoveItemFromArray($TempReturn, 0);
	}

	return $TempReturn;
}

function LoadFileIntoArray($MyFile)
{
	$MyArray = array();
	
	if (file_exists($MyFile))
	{
	
		$fh = fopen($MyFile,'r')		or die($php_errormsg);
		$tries = 3;
		while ($tries > 0)
		{
			$locked = flock($fh,LOCK_EX | LOCK_NB);
			if (! $locked)
			{
				sleep(2);
				$tries--;
			}
			else
			{
				$tries = 0;
			}
		}

		if ($locked)
		{

			$TempCount=0;
			while (!feof ($fh)) 
			{ 
				$buffer = fgets($fh); 
				if (!feof($fh))
				{
					$MyArray[$TempCount] = rtrim($buffer); 
					$TempCount=$TempCount+1;
				}
			} 

			flock($fh,LOCK_UN)			or die($php_errormsg);
			fclose($fh)					or die($php_errormsg);

		}
		else
		{
			print "Can't get lock on file :".$MyFile;
		}  
	}
	return $MyArray;
}

function LoadFile($myFile)
{
	$fileData = '';
	
	if (file_exists($myFile))
	{
		$fh = fopen($myFile,'r')		or die($php_errormsg);
		$tries = 3;
		while ($tries > 0)
		{
			$locked = flock($fh,LOCK_EX | LOCK_NB);
			if (! $locked)
			{
				sleep(5);
				$tries--;
			}
			else
			{
				$tries = 0;
			}
		}

		if ($locked)
		{
			$fileData = fread($fh, filesize($myFile))		or die($php_errormsg);	
			fflush($fh)										or die($php_errormsg);
			flock($fh,LOCK_UN)								or die($php_errormsg);
			fclose($fh)										or die($php_errormsg);
		}
		else
		{
			print "Can't get lock on file.";
		}  
	}
	return $fileData;
}

function ShowFile($myFile)
{
	$fh = fopen($myFile,'r')		or die($php_errormsg);
	$tries = 3;
	while ($tries > 0)
	{
		$locked = flock($fh,LOCK_EX | LOCK_NB);
		if (! $locked)
		{
			sleep(5);
			$tries--;
		}
		else
		{
			$tries = 0;
		}
	}

	if ($locked)
	{
		$fileData = fread($fh, filesize($myFile))		or die($php_errormsg);	
		fflush($fh)										or die($php_errormsg);
		flock($fh,LOCK_UN)								or die($php_errormsg);
		fclose($fh)										or die($php_errormsg);
	}
	else
	{
		print "Can't get lock on file.";
	}  

	echo $fileData;
}

function AppendToFile($myFile, $MyData)
{

	$fh = fopen($myFile,'a')		or die($php_errormsg);
	$tries = 3;
	while ($tries > 0)
	{
		$locked = flock($fh,LOCK_EX | LOCK_NB);
		if (! $locked)
		{
			sleep(5);
			$tries--;
		}
		else
		{
			$tries = 0;
		}
	}

	if ($locked)
	{
		fwrite($fh, $MyData)		or die($php_errormsg);	
		fflush($fh)					or die($php_errormsg);
		flock($fh,LOCK_UN)			or die($php_errormsg);
		fclose($fh)					or die($php_errormsg);
	}
	else
	{
		print "Can't get lock on file.";
	}  
}

function WriteToFile($myFile, $MyData)
{
	$fh = fopen($myFile,'w')		or die($php_errormsg);
	$tries = 3;
	while ($tries > 0)
	{
		$locked = flock($fh,LOCK_EX | LOCK_NB);
		if (! $locked)
		{
			sleep(5);
			$tries--;
		}
		else
		{
			$tries = 0;
		}
	}

	if ($locked)
	{
		fwrite($fh, $MyData)		or die($php_errormsg);	
		fflush($fh)					or die($php_errormsg);
		flock($fh,LOCK_UN)			or die($php_errormsg);
		fclose($fh)					or die($php_errormsg);
	}
	else
	{
		print "Can't get lock on file.";
	}  
}

function Format($Temp)
{
	return number_format($Temp, 2, '.', '');
}

function array_nsearch($needle, array $haystack)
{ 
	$it = new IteratorIterator(new ArrayIterator($haystack)); 
	foreach($it as $key => $val)
	{ 
		if(strcasecmp($val,$needle) === 0)
		{ 
			return $key; 
		} 
	} 
	return false; 
}

function SaveArrayToFile($myFile, $MyArray)
{
	$fh = fopen($myFile,"w+")		or die($php_errormsg);
	$tries = 3;
	while ($tries > 0)
	{
		$locked = flock($fh,LOCK_EX | LOCK_NB);
		if (! $locked)
		{
			sleep(5);
			$tries--;
		}
		else
		{
			$tries = 0;
		}
	}

	if ($locked)
	{
		foreach($MyArray as $key => $value)
		{
			fwrite($fh,$value."\r\n")	or die($php_errormsg);
		}
		fflush($fh)					or die($php_errormsg);
		flock($fh,LOCK_UN)			or die($php_errormsg);
		fclose($fh)					or die($php_errormsg);
	}
	else
	{
		print "Can't get lock on file.";
	}  
}

function create_zip($files = array(),$destination = '',$overwrite = false)
{ 

	//if the zip file already exists and overwrite is false, return false 
	if(file_exists($destination) && !$overwrite) { return false; } 
	//vars 
	$valid_files = array();
	//if files were passed in... 
	if(is_array($files)) { 
		//cycle through each file 
		foreach($files as $file) { 
			//make sure the file exists 
			if(file_exists($file)) { 
				$valid_files[] = $file;
			} 
		} 
	} 
	//if we have good files... 
	if(count($valid_files)) { 
		//create the archive 
		$zip = new ZipArchive();
		if($zip->open($destination,$overwrite ? ZIPARCHIVE::OVERWRITE : ZIPARCHIVE::CREATE) !== true) { 
			return false;
		} 
		//add the files 
		foreach($valid_files as $file) { 
			$zip->addFile($file,$file);
		} 
		//debug 
		//echo 'The zip archive contains ',$zip->numFiles,' files with a status of ',$zip->status; 
		
		//close the zip -- done! 
		$zip->close();
		
		//check to make sure the file exists 
		return file_exists($destination);
	} 
	else 
	{ 
		return false;
	} 
}

function DecodeMessage($TempData)
{
	
	$TempMessage = $TempData;
	$TempReturn = array();
	$TempLen = "";
	$TempValue = "";
	
	$TempCount = 1;
	
	while ((strlen($TempMessage)>0 && strpos($TempMessage,']')>0) && $TempCount<500)
	{
		$TempLen = substr($TempMessage, 1, strpos($TempMessage,']')-1);
		$TempValue = substr($TempMessage, strpos($TempMessage, ']')+1,$TempLen);
		
		$TempReturn[]=$TempValue;
		
		$TempMessage = substr($TempMessage, strlen($TempLen)+2+strlen($TempValue));
		
		$TempCount=$TempCount+1;
	}
	
	return $TempReturn;
	
}

function EncodeMessage($TempArray)
{
	$TempReturn = '';

	for ($t = 0; $t < count($TempArray); $t++)
	{
		$TempReturn = $TempReturn."[";
		$TempReturn = $TempReturn.strlen($TempArray[$t]);
		$TempReturn = $TempReturn."]";
		$TempReturn = $TempReturn.$TempArray[$t];
	}
	
	return $TempReturn;
}

function GetStringListItemWithZeroFallBack($TempList, $TempIndex)
{
	$TempReturn = '';
	
	if(array_key_exists($TempIndex,$TempList))
	{
		$TempReturn = $TempList[$TempIndex];
	}
	
	if ($TempReturn == '')
	{
		if(count($TempIndex) == 1)
		{
			if (count($TempList) > 0)
				{
				$TempReturn = $TempList[0];
				}
			
		}
		else
		{
			$TempReturn = "";
		}
		
	}
	
	return $TempReturn;
}

function RoundUpFrom($TempValue, $TempRoundUpFrom)
{
	$TempReturn = '';
	
	$TempRoundUpFromArray = str_split($TempRoundUpFrom);
	
	$TempZeroCount = 0;
	
	for ($t = 0; $t <= count($TempRoundUpFromArray) -1; $t++)
	{
		
		if ($TempRoundUpFromArray[$t] == '.')
		{
			$TempZeroCount = 0;
		}
		
		if ($TempRoundUpFromArray[$t] == '0')
		{
			$TempZeroCount++;
		}

	}
	
	$TempOne = .1;
	
	for ($t = $TempZeroCount; $t <= 2; $t++)
	{
		$TempOne = $TempOne/10;
	}
	
	$TempNewNumber = $TempOne - $TempRoundUpFrom;
	
	$TempNewNumber = $TempValue + $TempNewNumber;
	
	$TempReturnArray = str_split($TempNewNumber);
	
	$TempPassedDecimal = false;
	
	for ($t = 0; $t <= count($TempReturnArray) - 1; $t++)
	{
		
		if (!$TempPassedDecimal)
		{
			$TempReturn = $TempReturn.$TempReturnArray[$t];
		}
		
		if ($TempReturnArray[$t] == '.')
		{
			$TempPassedDecimal = true;
			//$TempReturn = $TempReturn.$TempReturnArray[$t];
		}
		else
		{
			if ($TempPassedDecimal)
			{
				$TempZeroCount = $TempZeroCount - 1;
				if ($TempZeroCount >= 0)
				{
					$TempReturn = $TempReturn.$TempReturnArray[$t];
				}
			}
		}
		
	}
	
	return $TempReturn;
}

function GetLoginTemplate($TempTongue)
{
	$TempMemberLoginTemplate = '';
	
	if ($_SESSION['LoggedIn'])
	{
		$TempMemberLoginTemplate = LoadFile('Templates/TTemplateMemberLoginLoggedIn'.$TempTongue.'.txt');
	}
	else
	{
		$TempMemberLoginTemplate = LoadFile('Templates/TTemplateMemberLoginLogin'.$TempTongue.'.txt');
	}

	return $TempMemberLoginTemplate;
}

function GetLoginName()
{
	$TempReturn = '';
	
	if (array_key_exists('Member', $_SESSION))
	{
		$TempMember = $_SESSION['Member'];
		
		if (array_key_exists('BusinessName', $TempMember))
		{
			$TempReturn = $TempMember['BusinessName'];		
		}
	}

	return $TempReturn;
}

function array_insert($src,$ins,$pos,$rep=0)
{ 
   array_splice($src,$pos,$rep,$ins); 
   return($src); 
 }
 
function array_removeAt($Temparray,$TempIndexToRemove)
{ 
	unset($Temparray[$TempIndexToRemove]);
	return array_values($Temparray);
}

?>
